<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Experimental Postcard Features"><meta name="keywords" content="rust, rustlang, rust-lang, experimental"><title>postcard::experimental - Rust</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc mod"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../postcard/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../postcard/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"><a href="#">Module experimental</a></h2><div class="sidebar-elems"></div></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../postcard/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="main-heading">
    <h1 class="fqn"><span class="in-band">Module <a href="../index.html">postcard</a>::<wbr><a class="mod" href="#">experimental</a><button id="copy-path" onclick="copy_path(this)" title="Copy item path to clipboard"><img src="../../clipboard.svg" width="19" height="18" alt="Copy item path"></button></span></h1><span class="out-of-band"><a class="srclink" href="../../src/postcard/lib.rs.html#55">source</a> · <a id="toggle-all-docs" href="javascript:void(0)" title="collapse all docs">[<span class="inner">&#x2212;</span>]</a></span></div><details class="rustdoc-toggle top-doc" open><summary class="hideme"><span>Expand description</span></summary><div class="docblock"><h2 id="experimental-postcard-features"><a href="#experimental-postcard-features">Experimental Postcard Features</a></h2>
<p>Items inside this module require various feature flags, and are not
subject to SemVer stability. Items may be removed or deprecated at
any point.</p>
<h3 id="derive"><a href="#derive">Derive</a></h3>
<p>The <code>experimental-derive</code> feature enables two experimental features:</p>
<ul>
<li>Max size calculation</li>
<li>Message schema generation</li>
</ul>
<h4 id="max-size-calculation"><a href="#max-size-calculation">Max Size Calculation</a></h4>
<p>This features enables calculation of the Max serialized size of a message as
an associated <code>usize</code> constant called <code>POSTCARD_MAX_SIZE</code>. It also provides a
<code>#[derive(MaxSize)]</code> macro that can be used for calculating user types.</p>
<p>This is useful for determining the maximum buffer size needed when recieving
or sending a message that has been serialized.</p>
<p>NOTE: This only covers the size of “plain” flavored messages, e.g. not with COBS
or any other Flavors applied. The overhead for these flavors must be calculated
separately.</p>
<p>Please report any missing types, or any incorrectly calculated values.</p>
<h4 id="message-schema-generation"><a href="#message-schema-generation">Message Schema Generation</a></h4>
<p>This feature enables the generation of a schema of a given message at compile
time. At the moment, this is only exposed as a <a href="crate::experimental::schema::NamedType"><code>NamedType</code></a>
which is a recursive data structure describing the schema. In the future, it is planned
to provide formatting functions that emit this as a human or machine readable schema.</p>
<p>NOTE: This only covers the schema of “plain” flavored messages, e.g. not with COBS
or any other Flavors applied. The format of these flavors must be calculated
separately.</p>
<p>Please report any missing types, or any incorrectly calculated schemas.</p>
</div></details></section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="postcard" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>